---
driver number: 0x70005
---

# L3GD20

## Overview

Three axis gyroscope and temperature sensor.

[Manual](https://www.pololu.com/file/0J563/L3GD20.pdf)

## Command

  * ### Command number: `0`

    **Description**: Returns SUCCESS

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: 0

  * ### Command number: `1`

    **Description**: Verifies whether the hardware sensor is present.

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.

  * ### Command number: `2`

    **Description**: Powers on the sensor.

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.

  * ### Command number: `3`

    **Description**: Sets the sensors scale

    **Argument 1**: 0, 1 or 2 (see manual 34)

    **Argument 2**: unused

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.

  * ### Command number: `4`

    **Description**: Enables or disables the high pass filter

    **Argument 1**: 1 for enable, 0 for disable

    **Argument 2**: unused

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.
  * ### Command number: `5`

    **Description**: Sets the high pass filter mode and divider

    **Argument 1**: mode (0, 1 or 2, see manual page 33)

    **Argument 2**: divider (0 .. 9, see manual page 33)

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.

  * ### Command number: `6`

    **Description**: Reads X, Y and Z

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.

  * ### Command number: `7`

    **Description**: Reads the temperature

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.

## Subscribe

All the commands return a callback when done.

  * ### Subscribe number `0`

    **Description**: Called when commands are done

	**Argument 1**: 
	  - Command 1: 1 present, 0 not present
	  - Command 6: X rotation
	  - Command 7: temperature in deg C

	**Argument 2**: 
	  - Command 6: Y rotation

	**Argument 3**: 
	  - Command 6: Z rotation

## Allow

Unused for the L3GD20 driver. Will always return `ENOSUPPORT`.

