---
driver number: 0x70006
---

# LSM303DLHC

## Overview

Three axis accelerometer, magnetometer and temperature sensor.

[Manual](https://www.st.com/resource/en/datasheet/lsm303dlhc.pdf)

## Command

  * ### Command number: `0`

    **Description**: Returns SUCCESS

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: 0

  * ### Command number: `1`

    **Description**: Performs a test read/write to verify that the hardware sensor is present.

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: `SUCCESS` if presence test has started successfully, `EBUSY` otherwise.

  * ### Command number: `2`

    **Description**: Set Accelerometer Power Mode.

    **Argument 1**: Accelerometer Data rate defined in manual table 20, page 25

    **Argument 2**: Low power mode (1 on, 0 off) 

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.

  * ### Command number: `3`

    **Description**: Set Accelerometer Scale and Resolution.

    **Argument 1**: Accelerometer scale defined in manual table 27, page 27

    **Argument 2**: High resolution (1 on, 0 off)

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.

  * ### Command number: `4`

    **Description**: Set Magnetometer Temperature Enable and Data Rate.

    **Argument 1**: Temperature enable (1 on, 0 off)

    **Argument 2**: Magnetometer Data rate defined in manual table 72, page 37

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.
    
  * ### Command number: `5`

    **Description**: Set magnetometer range.

    **Argument 1**: Magnetometer range defined in manual table 75, page 38

    **Argument 2**: unused

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.

  * ### Command number: `6`

    **Description**: Reads Acceleration X, Y and Z

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.

  * ### Command number: `7`

    **Description**: Reads the temperature

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.

  * ### Command number: `8`

    **Description**: Reads Magnetometer X, Y and Z

    **Argument 1**: unused

    **Argument 2**: unused

    **Returns**: `SUCCESS` if there is no other command in progress, `EBUSY` otherwise.

## Subscribe

All the commands return a callback when done.

  * ### Subscribe number `0`

    **Description**: Called when commands are done

	**Argument 1**: 
	  - Command 1: 1 present, 0 not present
	  - Command 6: X acceleration in m/s2 (not scaled)
	  - Command 7: temperature in deg C * 8
    - Command 8: X magnetometer in Gauss (not scaled)

	**Argument 2**: 
	  - Command 6: Y acceleration in m/s2 (not scaled)
    - Command 8: Y magnetometer in Gauss (not scaled)

	**Argument 3**: 
	  - Command 6: Z acceleration in m/s2 (not scaled)
    - Command 8: Z magnetometer in Gauss (not scaled)

## Allow

Unused for the LSM303DLHC driver. Will always return `ENOSUPPORT`.
